org.eclipse.incquery.viewmodel.traceablilty.generic

## Class GenericReferencedQuerySpecification

- java.lang.Object
- - org.eclipse.incquery.runtime.api.impl.BaseQuerySpecification<Matcher>
  - - org.eclipse.incquery.runtime.api.GenericQuerySpecification<GenericPatternMatcher>
    - - org.eclipse.incquery.viewmodel.traceablilty.generic.GenericReferencedQuerySpecification

- Type Parameters:
    `Matcher` -
  All Implemented Interfaces:
    IQuerySpecification<GenericPatternMatcher>, PQueryHeader

      public class GenericReferencedQuerySpecification
      extends GenericQuerySpecification<GenericPatternMatcher>

  Abstract IQuerySpecification implementation for resolving traced objects defined in annotations.
  Author:
    Csaba Debreceni

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `GenericReferencedQuerySpecification(GenericReferencedPQuery wrappedPQuery, IQuerySpecification<?> baseSpecification)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `IPatternMatch` | `createFromBaseMatch(IPatternMatch base)`
    `IQuerySpecification<?>` | `getBaseSpecification()`
    `java.lang.Class<? extends IncQueryScope>` | `getPreferredScopeClass()` The query is formulated over this kind of modeling platform.
    `java.util.Set<PParameter>` | `getReferenceParameters()`
    `static GenericReferencedQuerySpecification` | `initiate(IQuerySpecification<?> specification, com.google.common.collect.Multimap<PParameter,PParameter> traceSources, java.util.Map<PParameter,java.lang.String> traceIds, java.lang.String traceabilityId)`

    - ### Methods inherited from class org.eclipse.incquery.runtime.api.GenericQuerySpecification

      `newEmptyMatch, newMatch`

    - ### Methods inherited from class org.eclipse.incquery.runtime.api.impl.BaseQuerySpecification

      `getAllAnnotations, getAnnotationsByName, getFirstAnnotationByName, getFullyQualifiedName, getInternalQueryRepresentation, getMatcher, getMatcher, getParameterNames, getParameters, getPositionOfParameter`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### GenericReferencedQuerySpecification

          public GenericReferencedQuerySpecification(GenericReferencedPQuery wrappedPQuery,
                                                     IQuerySpecification<?> baseSpecification)

  - ### Method Detail

    - #### getPreferredScopeClass

          public java.lang.Class<? extends IncQueryScope> getPreferredScopeClass()

      Description copied from interface: `IQuerySpecification`
      The query is formulated over this kind of modeling platform. E.g. for queries over EMF models, the `EMFScope` class is returned.

    - #### initiate

          public static GenericReferencedQuerySpecification initiate(IQuerySpecification<?> specification,
                                                                     com.google.common.collect.Multimap<PParameter,PParameter> traceSources,
                                                                     java.util.Map<PParameter,java.lang.String> traceIds,
                                                                     java.lang.String traceabilityId)
                                                              throws QueryInitializationException

      Throws:
        `QueryInitializationException`

    - #### getReferenceParameters

          public final java.util.Set<PParameter> getReferenceParameters()

    - #### getBaseSpecification

          public final IQuerySpecification<?> getBaseSpecification()

    - #### createFromBaseMatch

          public IPatternMatch createFromBaseMatch(IPatternMatch base)